package com.steerinfo.meterwork.meterworkstoragecalibration.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkstoragecalibration.model.MeterWorkStorageCalibration;
import com.steerinfo.meterwork.meterworkstoragecalibration.service.IMeterWorkStorageCalibrationService;
import com.steerinfo.pretrack.prestoragescale.model.PreStorageScale;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkStorageCalibration RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-15 07:09
 * 类描述
 * 修订历史：
 * 日期：2021-10-15
 * 作者：generator
 * 参考：
 * 描述：MeterWorkStorageCalibration RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkstoragecalibrations")
public class MeterWorkStorageCalibrationController extends BaseRESTfulController {

    @Autowired
    IMeterWorkStorageCalibrationService meterWorkStorageCalibrationService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstoragecalibration:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkStorageCalibration> list = meterWorkStorageCalibrationService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstoragecalibration:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkStorageCalibration> list = meterWorkStorageCalibrationService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkStorageCalibration对象创建")
    @ApiImplicitParam(name = "meterWorkStorageCalibration", value = "详细实体meterWorkStorageCalibration", required = true, dataType = "MeterWorkStorageCalibration")
    //@RequiresPermissions("meterworkstoragecalibration:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkStorageCalibration model){
        MeterWorkStorageCalibration meterWorkStorageCalibration = meterWorkStorageCalibrationService.add(model);
        return success(meterWorkStorageCalibration);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstoragecalibration:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkStorageCalibration meterWorkStorageCalibration = meterWorkStorageCalibrationService.getById(id);
        return success(meterWorkStorageCalibration);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkStorageCalibration信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkStorageCalibration", value = "详细实体meterWorkStorageCalibration", required = true, dataType = "MeterWorkStorageCalibration")
    })
    //@RequiresPermissions("meterworkstoragecalibration:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkStorageCalibration model){
        model.setId(id);
        MeterWorkStorageCalibration meterWorkStorageCalibration = meterWorkStorageCalibrationService.modify(model);
        return success(meterWorkStorageCalibration);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstoragecalibration:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkStorageCalibrationService.delete(ids);
    	}
      return success();
    }


    @ApiOperation(value = "批量新增数据", notes = "界面填写数据，服务端做二次校验及赋值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doAddWf")
    public RESTfulResult doAddWf(@RequestBody List<MeterWorkStorageCalibration> models) {
        RESTfulResult rm = failed();
        try {
            String str = meterWorkStorageCalibrationService.doAddWf(models);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "批量新增数据", notes = "界面填写数据，服务端做二次校验及赋值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doAddManual")
    public RESTfulResult doAddManual(@RequestBody List<MeterWorkStorageCalibration> models) {
        RESTfulResult rm = failed();
        try {
            String str = meterWorkStorageCalibrationService.doAddManual(models);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "新增“未生产”的校秤数据", notes = "界面填写数据，服务端做二次校验及赋值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doAddNotProd")
    public RESTfulResult doAddNotProd(@RequestBody List<MeterWorkStorageCalibration> models) {
        RESTfulResult rm = failed();
        try {
            String str = meterWorkStorageCalibrationService.doAddNotProd(models);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }


    @ApiOperation(value = "批量修改数据", notes = "界面填写数据，服务端做二次校验及赋值")
    @Transactional(rollbackFor = {MarkerMetException.class, Exception.class})
    @PostMapping(value = "/doUpdateWf")
    public RESTfulResult doUpdateWf(@RequestBody List<MeterWorkStorageCalibration> models) {
        RESTfulResult rm = failed();
        try {
            String str = meterWorkStorageCalibrationService.doUpdateWf(models);
            if (StringUtils.isEmpty(str)) {
                return success();
            } else {
                return failed("操作失败!" + str);
            }
        }catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
